import java.io.*; 
import java.util.*;

import javax.swing.JOptionPane;

import org.w3c.dom.*;

//import com.sun.org.apache.xerces.internal.impl.xs.dom.DOMParser;

import org.apache.xerces.parsers.DOMParser;


public class ConfigFileManager {
	private DOMParser parser;
	private Document doc;
	private Vector clientsList;
	private Vector storageList;
	private Vector mdsList;
	private String codeVersion;
	private String underlyingFS;
	private boolean runTcpDump;
	private boolean runIoStat;
		
	public Vector getClients(){
		return clientsList;
	}
	
	public Vector getStorage(){
		return storageList;
	}
	
	public Vector getMds(){
		return mdsList;
	}
	
	public boolean getTcpDump(){
		return runTcpDump;
	}
	
	public boolean getIoStat(){
		return runIoStat;
	}
	
	ConfigFileManager(String path){
		try{
			clientsList = new Vector();
			storageList = new Vector();
			mdsList = new Vector();
			codeVersion = new String();
			underlyingFS = new String();
			runTcpDump = false;
			runIoStat = false;
			
			parser = new DOMParser();
			parser.parse(path);
			doc = parser.getDocument();
			
			
			Node n = doc.getFirstChild();
			while (n!=null && !n.getNodeName().equalsIgnoreCase("config")){ 
				 System.out.println(n.getNodeName());
				 n = n.getNextSibling();
			 }
			if(n!=null && n.getNodeName().equals("config")){
				n = n.getFirstChild();
				while(n!=null){
					Node temp;
				//System.out.println("dfasd" + n.getNodeName());
					if(n.getNodeName().equalsIgnoreCase("client")){
						temp = n;
						String defaultmountpoint = new String();
						String defaultIoZonePath = new String();
						NamedNodeMap attrs = temp.getAttributes();
						int len = attrs.getLength();
						for (int i=0; i<len; i++) {
							Attr attr = (Attr)attrs.item(i);
							if(attr.getName().equalsIgnoreCase("mountpoint")){
								defaultmountpoint = attr.getTextContent();
							}
							if(attr.getName().equalsIgnoreCase("iozone")){
								defaultIoZonePath = attr.getTextContent();
							}
						}
						parseClients(temp, defaultmountpoint, defaultIoZonePath);	
					}
				
					if(n.getNodeName().equalsIgnoreCase("storage")){
						temp = n;
						String defaultmountpoint2 = new String();
						NamedNodeMap attrs2 = temp.getAttributes();
						int len2 = attrs2.getLength();
						for (int i=0; i<len2; i++) {
							Attr attr2 = (Attr)attrs2.item(i);
							if(attr2.getName().equalsIgnoreCase("disk")){
								defaultmountpoint2 = attr2.getTextContent();
							}
							if(attr2.getName().equalsIgnoreCase("iostat")){
								runIoStat = (attr2.getTextContent().equalsIgnoreCase("yes"))?true:false;
							}
						}
						parseStorage(temp, defaultmountpoint2);
					}
				
					if(n.getNodeName().equalsIgnoreCase("mds")){
						temp = n;
						parseMds(temp);
					}
					
							
					if(n.getNodeName().equalsIgnoreCase("setup")){
						NamedNodeMap attrs3 = n.getAttributes();
						int len3 = attrs3.getLength();
						for (int i=0; i<len3; i++) {
							Attr attr3 = (Attr)attrs3.item(i);
							if(attr3.getName().equalsIgnoreCase("version")){
								codeVersion = attr3.getTextContent();
							}
							if(attr3.getName().equalsIgnoreCase("pwd")){
								Utils.setPwd(attr3.getTextContent());
							}
							if(attr3.getName().equalsIgnoreCase("fs")){
								underlyingFS = attr3.getTextContent();
							}
							if(attr3.getName().equalsIgnoreCase("tcpdump")){
								runTcpDump = (attr3.getTextContent().equalsIgnoreCase("yes"))?true:false;
							}
						}
					}
					
					n = n.getNextSibling();	
				}
			}
			 
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void parseMds(Node n){
		n = n.getFirstChild();	
		n = n.getNextSibling();
		
			
		while(n != null){
			NamedNodeMap attrs = n.getAttributes();
			int len = attrs.getLength();
			for (int i=0; i<len; i++) {
				Attr attr = (Attr)attrs.item(i);
				mdsList.add(attr.getTextContent());
			}
	
			n = n.getNextSibling();
			n = n.getNextSibling();
		}
		
	}
	private void parseClients(Node n, String defaultmount, String defaultIoZonePath){
		String name = new String("");
		String mountPoint = new String(defaultmount);
		String IoZonePath = new String(defaultIoZonePath);
	
		n = n.getFirstChild();
		n = n.getNextSibling();
		while(n!= null){
			NamedNodeMap attrs = n.getAttributes();
	
	
			int len = attrs.getLength();
			for (int i=0; i<len; i++) {
				Attr attr = (Attr)attrs.item(i);
				if(attr.getName().equalsIgnoreCase("name")){
					name = attr.getTextContent();
				}
				else if(attr.getName().equalsIgnoreCase("mountpoint")){
					mountPoint = attr.getTextContent();
				}
				else if(attr.getName().equalsIgnoreCase("iozone")){
					IoZonePath = attr.getTextContent();
				}
			}
			clientsList.add(new ClientConfig(name, mountPoint, IoZonePath));
			
			n = n.getNextSibling();
			n = n.getNextSibling();
			name = "";
			mountPoint = defaultmount;
			IoZonePath = defaultIoZonePath;
		}
	}
	
	private void parseStorage(Node n, String defaultmount){
		String name = new String("");
		String mountPoint = new String(defaultmount);
		n = n.getFirstChild();
		n = n.getNextSibling();
		while(n!= null){
			NamedNodeMap attrs = n.getAttributes();
			int len = attrs.getLength();
			for (int i=0; i<len; i++) {
				Attr attr = (Attr)attrs.item(i);
				if(attr.getName().equalsIgnoreCase("name")){
					name = attr.getTextContent();
				}
				else if(attr.getName().equalsIgnoreCase("disk")){
					mountPoint = attr.getTextContent();
				}
			}
			storageList.add(new StorageConfig(name, mountPoint));
			
			n = n.getNextSibling();
			n = n.getNextSibling();
			name = "";
			mountPoint = defaultmount;
		}
	}
	
	public void generateAllMachineFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector s = getStorage();
			Vector c = getClients();
			Vector m = getMds();
			  for(int i = 0; i < s.size(); i++){
				  StorageConfig cf =(StorageConfig) s.elementAt(i);
				  writer.write(cf.getStorageName() + "\n");
			  }
			  for(int i = 0; i < c.size(); i++){
				  ClientConfig cf =(ClientConfig) c.elementAt(i);
				  writer.write(cf.getClientName() + "\n");
			  }
			  for(int i = 0; i < m.size(); i++){
				  writer.write(m.elementAt(i) + "\n");
			  }

			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generateStorageFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getStorage();
			  for(int i = 0; i < v.size(); i++){
				  StorageConfig cf =(StorageConfig) v.elementAt(i);
				  writer.write(cf.getStorageName() + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generateDiskFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getStorage();
			  for(int i = 0; i < v.size(); i++){
				  StorageConfig cf =(StorageConfig) v.elementAt(i);
				  writer.write(cf.getMountPoint() + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generatePartitionFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getStorage();
			  for(int i = 0; i < v.size(); i++){
				  StorageConfig cf =(StorageConfig) v.elementAt(i);
				  String temp = cf.getMountPoint();
				  temp = temp.substring(temp.lastIndexOf('/') + 1, temp.length());
				  //System.out.println(temp);
				  writer.write(temp + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generateIoZoneClientFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getClients();
			  for(int i = 0; i < v.size(); i++){
				  ClientConfig cf =(ClientConfig) v.elementAt(i);
				  writer.write(cf.getClientName() + " " + cf.getMountPoint() + " " + cf.getIoZonePath()+"/iozone" + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	public void generateClientFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getClients();
			  for(int i = 0; i < v.size(); i++){
				  ClientConfig cf =(ClientConfig) v.elementAt(i);
				  writer.write(cf.getClientName() + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generateMountPointFile(String filename){
		try{
			FileWriter writer = new FileWriter(filename);
			Vector v = getClients();
			  for(int i = 0; i < v.size(); i++){
				  ClientConfig cf =(ClientConfig) v.elementAt(i);
				  writer.write(cf.getMountPoint() + "\n");
			  }
			  writer.flush();
			  writer.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public String getCodeVersion(){
		return codeVersion;
	}
	
	public String getUnderlyingFs(){
		return underlyingFS;
	}

}