#!/bin/bash
# Description: This file is the network performance diagnostic test script for 
# the pNFS regression suite and performance debugging tool chain. It calculates the performance of the link between all the nodes.
# Stage: 0 
# Author: Zainul Abedin (zja) & Swaroop Choudhari (svchoudh)
# Inputs: 
# Detailed Description: 
# Stage0 of the test suite is used to get Experimental setup information. 

count_numruns="0"


FILE_SIZE=512
ACCESS_SIZE=1024

declare -a servers
i=0

if (([ -s "$client_list" ]) && ([ -r "$client_list" ]))
    then
    
    if (([ -s "$storage_nodes_list" ]) && ([ -r "$storage_nodes_list" ]))
	then
	for server in `cat "$storage_nodes_list"`; do
	    temp="$temp"" ""$server"
	    echo $temp
	    servers[i]=$temp
	    let "i=$i+1"
	done
    else
	echo "error in netSat_perf.sh no file" $storage_node_list
	exit -1
    fi
    
    element_count=${#servers[*]}

    echo "Starting netSat server on every node"
    dsh -g storage_nodes -c -- "netSat_server" & 
   
    sleep 5

    for client in `cat $client_list`; do
	num_servers=0
	while [ "$num_servers" -lt "$element_count" ]; do
	    
	    let "count_numruns=0"
	    echo "running netSat on "$client" withh server/s "${servers[$num_servers]}
	    while [ "$count_numruns" -lt "$num_runs" ]; do
		dsh -m $client -- " netSat_client $FILE_SIZE $ACCESS_SIZE $(($num_servers+1)) ${servers[$num_servers]} >> /tmp/netSat_perf.txt"
		let "count_numruns=$count_numruns+1"
	    done
	    let "num_servers=$num_servers+1"
	    temp="$SAVE_AS"
	    dsh -m $client -- "insert_netsat_perf $DB_SERVER $num_runs $client $num_servers \"$temp\" "
	    dsh -m $client -- " rm -rf /tmp/netSat_perf.txt"
	    
	done
    done
    echo "killing the netSat servers"
    dsh -g storage_nodes -c -- "killall -sSIGKILL netSat_server"
else
    echo "STAGE0-DIAGNOSIS PHASE:  netSat - Invalid file:" $client_list
    exit
fi
