import java.io.FileWriter;
import java.sql.*;
import java.util.*;
import java.awt.*; 
import java.awt.event.*;
import javax.swing.*; 

import javax.swing.JPanel;

import quicktime.qd.text.ScrpSTElement;
public class Plotter {
	private dbConnection dbCon;
	private ExecuteCommand ec;
	
	Plotter(){
		dbCon = new dbConnection();
		ec = new ExecuteCommand();
	}
	
	public void plotAutoReport(String reg, float fileSize, String mode,String client ) {
		ResultSet rsReg1;
		
		AutoReport auto;
		Vector<AutoReport> autoReportData = new Vector<AutoReport>();
		
		String fileName = new String("/tmp/preg/plots/Autoreport_" + reg + "_" + 
				(int) fileSize + "_" + mode + "_" + client);
		int base = 4;
		float val =0;
		for(int i = 0; val < 16*1024; i++ ){
			val = (float) Math.pow(2, i)*base;
			auto = new AutoReport(val, reg);
			
			
			//TODO
			String cmd ="select file_size, value from benchmark_perf_info " +
			"where entry_name = \"" + reg + "\" and record_size= " + 
			val + " and type_of_test=\"" + mode + "\" and client_name = \"" + client + "\" order by file_size";
			
			
			rsReg1 = dbCon.createExecuteQuery(cmd);
			
			
			auto.enterRegressionData(rsReg1);
		
			
			autoReportData.add(auto);
		
		}
		
		generateGnuPlotFile(autoReportData, reg, fileSize, mode, fileName);
		
		generateGnuPlotScript(fileName,fileSize, reg, mode,client);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
		
	}
		
	public void plotAutoReport(String reg1, String reg2, String client1,
			String client2, float fileSize, String mode ) {
		ResultSet rsReg1;
		ResultSet rsReg2;
		AutoReport auto, auto2;
		Vector<AutoReport> autoReportData = new Vector<AutoReport>();
		Vector<AutoReport> autoReportData2 = new Vector<AutoReport>();
		String fileName = new String("/tmp/preg/plots/Autoreport_" + reg1 + "_" + reg2 + "_" + 
				(int) fileSize + "_" + mode + "_" + client1 + "vs" + client2);
		int base = 4;
		float val =0;
		for(int i = 0; val < 16*1024; i++ ){
			val = (float) Math.pow(2, i)*base;
			auto = new AutoReport(val, reg1);
			auto2 = new AutoReport(val, reg2);
			
			//TODO
			String cmd ="select file_size, value from benchmark_perf_info " +
			"where entry_name = \"" + reg1 + "\" and record_size= " + 
			val + " and type_of_test=\"" + mode + "\" and client_name = \"" + client1 +
			"\" order by file_size";
			
			
			rsReg1 = dbCon.createExecuteQuery(cmd);
			
			cmd ="select file_size, value from benchmark_perf_info " +
			"where entry_name = \"" + reg2 +"\" and record_size= " + 
			val + " and type_of_test=\"" + mode + "\" and client_name = \"" + 
			client2 +"\" order by file_size";
			
			rsReg2 = dbCon.createExecuteQuery(cmd);
		
			auto.enterRegressionData(rsReg1);
			auto2.enterRegressionData(rsReg2);
			
			autoReportData.add(auto);
			autoReportData2.add(auto2);
		}
		
		generateGnuPlotFile(autoReportData, reg1, autoReportData2, reg2, fileSize, mode, fileName);
		
		generateGnuPlotScript(fileSize, fileName, reg1, reg2, mode, client1, client2);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
		
	}

	public void plotVaryingFileSize(String reg, float minFileSize, float maxFileSize, 
			float recordSize, String mode, String client ) {
		ResultSet rsReg1;
		
		VaryingFileSize vfsReport = new VaryingFileSize(recordSize, reg);
		
		
		String fileName = new String("/tmp/preg/plots/VaryingFileSize_" + reg + "_" + 
				(int) minFileSize + "_" + (int) maxFileSize + "_" + (int)recordSize + "_" + mode + 
				"_" + client);
		
		
			//TODO
			//String cmd ="select file_size, value from benchmark_perf_info " +
			//"where entry_name = \"" + reg1 + "\" and record_size= " + 
			//val + " and type_of_test=\"" + mode + "\" order by file_size";
			
			String cmd ="select file_size, value from benchmark_perf_info " +
					"where entry_name = \"" + reg +"\" and record_size= " + 
					recordSize + " and type_of_test=\"" + mode + "\" and file_size >=" + 
					minFileSize + "and file_size <=" + maxFileSize + " and client_name = \"" + 
					client +"\" order by file_size";
			
			
			rsReg1 = dbCon.createExecuteQuery(cmd);
			
			vfsReport.enterRegressionData(rsReg1);
		

		generateGnuPlotFile(vfsReport , reg, minFileSize, maxFileSize, mode, fileName);
		
		generateGnuPlotScript(fileName, reg, mode,recordSize,client);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
				
	}
	
	public void plotVaryingFileSize(String reg1, String reg2, String client1, String client2, 
			float minFileSize, float maxFileSize, float recordSize, String mode ) {
		ResultSet rsReg1,rsReg2;
		
		VaryingFileSize vfsReport1 = new VaryingFileSize(recordSize, reg1);
		VaryingFileSize vfsReport2 = new VaryingFileSize(recordSize, reg2);
		
		String fileName = new String("/tmp/preg/plots/VaryingFileSize_" + reg1 + "_" + reg2 + 
				"_" + (int) minFileSize + "_" + (int) maxFileSize + "_" + (int)recordSize + "_" + mode
				+ "_" + client1 + "_" + client2 );
		
		System.out.println(fileName);
		
			//TODO
			//String cmd ="select file_size, value from benchmark_perf_info " +
			//"where entry_name = \"" + reg1 + "\" and record_size= " + 
			//val + " and type_of_test=\"" + mode + "\" order by file_size";
			
			String cmd ="select file_size, value from benchmark_perf_info " +
					"where entry_name = \"" + reg1 +"\" and record_size= " + 
					recordSize + " and type_of_test=\"" + mode + "\" and file_size >=" + 
					minFileSize + "and file_size <=" + maxFileSize + " and client_name = \"" +
					client1 +"\" order by file_size";
			
			
			rsReg1 = dbCon.createExecuteQuery(cmd);
			System.out.println(client2);
			cmd = "select file_size, value from benchmark_perf_info " +
				"where entry_name = \"" + reg2 +"\" and record_size= " + 
				recordSize + " and type_of_test=\"" + mode + "\" and file_size >=" + 
				minFileSize + "and file_size <=" + maxFileSize + " and client_name = \"" +
				client2 +"\" order by file_size";
	
			rsReg2 = dbCon.createExecuteQuery(cmd);		
			
			vfsReport1.enterRegressionData(rsReg1);
			vfsReport2.enterRegressionData(rsReg2);
		

		generateGnuPlotFile(vfsReport1 , reg1, vfsReport2, reg2, minFileSize, maxFileSize, 
				mode, fileName);
		
		generateGnuPlotScript(fileName, reg1, reg2, mode,recordSize,client1,client2);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
				
	}
	
	public void plotMultipleClientReport(String reg, int minNumClients, int maxNumClients, 
			float fileSize, float recordSize){

		ResultSet rsReg1;
		
		MultiClientReport mcReport = new MultiClientReport(fileSize,recordSize,reg);
				
		String fileName = new String("/tmp/preg/plots/MultiClient_" + reg + "_" + minNumClients +
				"_" + maxNumClients + "_" + (int) fileSize + "_" + (int)recordSize);
		
			
			
		//TODO
		//String cmd ="select file_size, value from benchmark_perf_info " +
		//"where entry_name = \"" + reg1 + "\" and record_size= " + 
		//val + " and type_of_test=\"" + mode + "\" order by file_size";
		
		String cmd ="select num_clients, value, type_of_test from benchmark_perf_info " +
		"where entry_name = \"" + reg +"\" and record_size= " + recordSize + 
		"and file_size= " + fileSize + " and (type_of_test=\"multi_read\" " +
		"or type_of_test=\"multi_write\") order by num_clients";
		

		rsReg1 = dbCon.createExecuteQuery(cmd);
			
		mcReport.enterRegressionData(rsReg1);
							
		generateGnuPlotFile(mcReport, reg, minNumClients, maxNumClients, fileSize, 
			recordSize, fileName);
		
		generateGnuPlotScript(fileSize, recordSize, fileName, reg);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
		
		
	}
	
	public void plotMultipleClientReport(String reg1, String reg2, int minNumClients, int maxNumClients, 
			float fileSize, float recordSize){

		ResultSet rsReg1,rsReg2;
		
		MultiClientReport mcReport1 = new MultiClientReport(fileSize,recordSize,reg1);
		MultiClientReport mcReport2 = new MultiClientReport(fileSize,recordSize,reg2);
				
		String fileName = new String("/tmp/preg/plots/MultiClient_" + reg1 + "_" + reg2 + "_" + minNumClients +
				"_" + maxNumClients + "_" + (int) fileSize + "_" + (int)recordSize);
		
			
		String cmd ="select num_clients, value, type_of_test from benchmark_perf_info " +
		"where entry_name = \"" + reg1 +"\" and record_size= " + recordSize + 
		"and file_size= " + fileSize + " and (type_of_test=\"multi_read\" " +
		"or type_of_test=\"multi_write\") order by num_clients";
		
		rsReg1 = dbCon.createExecuteQuery(cmd);
		
		cmd ="select num_clients, value, type_of_test from benchmark_perf_info " +
		"where entry_name = \"" + reg2 +"\" and record_size= " + recordSize + 
		"and file_size= " + fileSize + " and (type_of_test=\"multi_read\" " +
		"or type_of_test=\"multi_write\") order by num_clients";
		
		rsReg2 = dbCon.createExecuteQuery(cmd);
			
		mcReport1.enterRegressionData(rsReg1);
		mcReport2.enterRegressionData(rsReg2);
		
		generateGnuPlotFile(mcReport1, reg1, mcReport2, reg2, minNumClients, maxNumClients, fileSize, 
			recordSize, fileName);
		
		generateGnuPlotScript(fileSize, recordSize, fileName, reg1, reg2);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
				
	}
	
	private void plotGraph(String fileName){
		
		ShowGraph sg = new ShowGraph(fileName);
		JPanel Mainpanel = new JPanel();
		Mainpanel.add(sg.getPicture());
		Mainpanel.setVisible(true);
		JFrame jf = new JFrame();
		jf.setContentPane(Mainpanel);
		jf.setSize(sg.getPictureDimension());
		jf.setVisible(true);
	}
			
	private void runGnuPlot(String file){
		try{
			ec.runAndWait("gnuplot " + file);
		}
		catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
		
	private void generateGnuPlotScript(String fName, float filesz, 
			String reg1, String mode, String client){
	String inputfile = new String(fName + ".dat");
	String outputfile = new String(fName + ".gnuplot");
	String plotName = new String(fName + ".png");
	if(mode.equalsIgnoreCase("read")){
		mode = "Read";
	}
	else{
		mode = "Write";
	}
		
	try{
		int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
		
		FileWriter writer = new FileWriter(outputfile);
		writer.write("set terminal png small color picsize 800 600 \n");
		writer.write("set pointsize 1.5 \n");
		writer.write("set output\"" + plotName + "\"" + "\n");
		writer.write("set origin 0, 0 \n");
		writer.write("set logscale x \n");
		writer.write("set title \"" + client + " " + mode + " Throughput Vs RecordSize for FileSize " + filesz + "\"\n");
		writer.write("set ylabel \"Throughput(KBps)\"\n");
		writer.write("set xlabel \"RecordSize (KB)\"\n");
		writer.write("set grid\n");
		writer.write("set xtics (4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384)\n");
		writer.write("set yr [0:" + yMax + "]\n");
		writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" 
				+reg1 +"\'" +  " with linespoints \n");
		writer.flush();
		writer.close();

	}
	catch(Exception e){
		e.printStackTrace();
	}
}

	private void generateGnuPlotScript(String fName, String reg1, String mode,float recordsize, 
			String client){
	String inputfile = new String(fName + ".dat");
	String outputfile = new String(fName + ".gnuplot");
	String plotName = new String(fName + ".png");
	if(mode.equalsIgnoreCase("small_read") || mode.equalsIgnoreCase("large_read")){
		mode = "Read";
	}
	else{
		mode = "Write";
	}
		
	try{
		int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
		
		FileWriter writer = new FileWriter(outputfile);
		writer.write("set terminal png small color picsize 800 600 \n");
		writer.write("set pointsize 1.5 \n");
		writer.write("set output\"" + plotName + "\"" + "\n");
		writer.write("set origin 0, 0 \n");
		writer.write("set logscale x \n");
		writer.write("set title \" Single Client " + client + " "+ mode + 
				" Throughput Vs FileSize for RecordSize " + recordsize + "\"\n");
		writer.write("set ylabel \"Throughput(KBps)\"\n");
		writer.write("set xlabel \"FileSize (KB)\"\n");
		writer.write("set grid\n");
		writer.write("set xtics (64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, " +
				"131072, 262144, 524288, 1048576, 2097152, 4194304, 8388608)\n");
		writer.write("set yr [0:" + yMax + "]\n");
		writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" 
				+reg1 +"\'" +  " with linespoints \n");
		writer.flush();
		writer.close();

	}
	catch(Exception e){
		e.printStackTrace();
	}
}
	
	private void generateGnuPlotScript(float filesz, String fName, 
				String reg1, String reg2, String mode, String client1, String client2){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
		if(mode.equalsIgnoreCase("read")){
			mode = "Read";
		}
		else{
			mode = "Write";
		}
			
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set logscale x \n");
			writer.write("set title \"" + mode + " Throughput Vs RecordSize for FileSize " + filesz + "\"\n");
			writer.write("set ylabel \"Throughput(KBps)\"\n");
			writer.write("set xlabel \"RecordSize (KB)\"\n");
			writer.write("set grid\n");
			writer.write("set xtics (4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384)\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" 
					+reg1 + " client " + client1 +"\'" +  " with linespoints,"+ "\"" + inputfile + "\""+
					" using 1:3 title '" + reg2 + " client " + client2 + "\'" + " with linespoints\n");
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	private void generateGnuPlotScript(String fName, String reg1, String reg2, String mode, 
			float recordsize, String client1, String client2){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
		if(mode.equalsIgnoreCase("small_read") || mode.equalsIgnoreCase("large_read")){
			mode = "Read";
		}
		else{
			mode = "Write";
		}
			
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set logscale x \n");
			writer.write("set title \" Single Client " + mode + 
					" Throughput Vs FileSize for RecordSize " + recordsize + "\"\n");
			writer.write("set ylabel \"Throughput(KBps)\"\n");
			writer.write("set xlabel \"FileSize (KB)\"\n");
			writer.write("set grid\n");
			writer.write("set xtics (64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, " +
					"131072, 262144, 524288, 1048576, 2097152, 4194304, 8388608)\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" 
					+reg1 + " client " + client1 + 
					"\'" +  " with linespoints,"+ "\"" + inputfile + "\""+
					" using 1:3 title '" + reg2 + " client " + client2 
					+ "\'" + " with linespoints\n");
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
 	
	private void generateGnuPlotScript(float fsize, float rsize, String fName, String reg){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
			
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set title \" Multiple Clients Write/Read" + 
					" Throughput Vs Number of Clients for FileSize " + fsize + 
					"and RecordSize " + rsize + "\"\n");
			writer.write("set ylabel \"Throughput(KBps)\"\n");
			writer.write("set xlabel \"Number of Clients (KB)\"\n");
			writer.write("set grid\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" +  reg + " Write"  
					+  "\' with linespoints,"+ "\"" + inputfile + "\""+
					" using 1:3 title \'" + reg + " Read\'" + " with linespoints\n");
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void generateGnuPlotScript(float fsize, float rsize, String fName, 
			String reg1, String reg2){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
			
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set title \" Multiple Clients Write/Read" + 
					" Throughput Vs Number of Clients for FileSize " + fsize + 
					"and RecordSize " + rsize + "\"\n");
			writer.write("set ylabel \"Throughput(KBps)\"\n");
			writer.write("set xlabel \"Number of Clients (KB)\"\n");
			writer.write("set grid\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write("plot \"" + inputfile + "\" using 1:2 title " + "\'" +  reg1 + " Write"  
					+  "\' with linespoints,"+ "\"" + inputfile + "\""+ " using 1:3 title \'" + reg1 
					+ " Read\'" + " with linespoints,"+ "\"" + inputfile + "\"" + 
					" using 1:4 title \'" + reg2 + " Write\'" + " with linespoints,"+ "\"" + inputfile + "\""+
					" using 1:5 title \'" + reg2 + " Read\'" + " with linespoints\n");
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void generateGnuPlotFile(Vector<AutoReport> autoVec1, String reg1, 
			float filesz, String mode, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val;
			int maxVal=0;
			AutoReport auto1;
			for(int i = 0;  i < autoVec1.size(); i++) {
				auto1 = autoVec1.get(i);
						val = auto1.getThroughput(filesz);
						writer.write(auto1.getRecordSize() + " ");
						if(val != null){
							if(val.intValue()>maxVal){
								maxVal = val.intValue();
							}
							writer.write( val.toString() + " ");
						}
						else {
							writer.write("-" + " ");
						}
						writer.write("\n");
					}
				
				
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}
	
	private void generateGnuPlotFile(Vector<AutoReport> autoVec1, String reg1, 
			Vector<AutoReport> autoVec2, String reg2, float filesz, String mode, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val, val2 ;
			int maxVal=0;
			AutoReport auto1, auto2;
			for(int i = 0;  i < autoVec1.size(); i++) {
				auto1 = autoVec1.get(i);
				for(int j = 0; j < autoVec2.size(); j++){
					auto2  = autoVec2.get(j);
					if(auto1.getRecordSize() == auto2.getRecordSize()){
						val = auto1.getThroughput(filesz);
						val2 = auto2.getThroughput(filesz);
						
						writer.write(auto1.getRecordSize() + " ");
						if(val != null){
							int temp = Utils.maxNumber(val.intValue(),val2.intValue());
							if(temp>maxVal){
								maxVal = temp;
							}
							writer.write( val.toString() + " ");
						}
						else {
							writer.write("-" + " ");
						}
						if(val2 != null){
							writer.write( val2.toString() + " ");
						}
						else {
							writer.write("-" + " 	");
						}
						writer.write("\n");
					}
				}
				
			}
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}

	private void generateGnuPlotFile(VaryingFileSize vfs, String reg1, 
			float minfilesz, float maxfilesz, String mode, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val;
			int maxVal=0;
			float filesz = minfilesz;		
			for(int i=0;filesz<=maxfilesz;i++){
				val = vfs.getThroughput(filesz);
				writer.write(filesz + " ");
				if(val != null){
					if(val.intValue()>maxVal){
						maxVal = val.intValue();
					}
					writer.write( val.toString());
				}
				else {
					writer.write("-" + " ");
				}
				writer.write("\n");
				filesz = (float) (Math.pow(2,i)*minfilesz); 
					
			}
				
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}

	private void generateGnuPlotFile(VaryingFileSize vfs1, String reg1, VaryingFileSize vfs2, 
			String reg2, float minfilesz, float maxfilesz, String mode, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val1,val2;
			int maxVal=0;
			float filesz = minfilesz;		
			for(int i=0;filesz<=maxfilesz;i++){
				val1 = vfs1.getThroughput(filesz);
				val2 = vfs2.getThroughput(filesz);
				writer.write(filesz + " ");
				if(val1 != null && val2!=null){
					int temp = Utils.maxNumber(val1.intValue(), val2.intValue());
					if(temp > maxVal){
						maxVal = temp;
					}
					writer.write( val1.toString() + " ");
				}
				else {
					writer.write("-" + " ");
				}
				if(val2 != null){
					writer.write( val2.toString() + " ");
				}
				else {
					writer.write("-" + " 	");
				}
				writer.write("\n");
				filesz = (float) (Math.pow(2,i+1)*minfilesz); 
					
			}
				
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}

	private void generateGnuPlotFile(MultiClientReport mcr, String reg1, 
			int minClients, int maxClients, float fsize, float rsize, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val1, val2;
			int maxVal=0;
			int numClients = minClients;		
			for(int i=0;numClients<=maxClients;i++){
				val1 = mcr.getWriteThroughput(numClients);
				val2 = mcr.getReadThroughput(numClients);
				writer.write(numClients + " ");
				if(val1 != null){
					int temp = Utils.maxNumber(val1.intValue(), val2.intValue());
					if(temp>maxVal){
						maxVal = temp;
					}
					writer.write(val1.toString() + " ");
				}
				if(val2 != null){
					if(val2.intValue()>maxVal){
						maxVal = val2.intValue();
					}
					writer.write(val2.toString() + " ");
				}
				else {
					writer.write("-" + " ");
				}
				writer.write("\n");
				numClients++; 
					
			}
				
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}

	private void generateGnuPlotFile(MultiClientReport mcr1, String reg1,MultiClientReport mcr2,
			String reg2, int minClients, int maxClients, float fsize, float rsize, String fName){
		
		String fileName = new String(fName + ".dat");
		try{
			FileWriter writer = new FileWriter(fileName);
			Float val1, val2, val3, val4;
			int maxVal=0;
			int numClients = minClients;		
			for(int i=0;numClients<=maxClients;i++){
				val1 = mcr1.getWriteThroughput(numClients);
				val2 = mcr1.getReadThroughput(numClients);
				val3 = mcr2.getWriteThroughput(numClients);
				val4 = mcr2.getReadThroughput(numClients);
				writer.write(numClients + " ");
				if(val1 != null){
					int temp = Utils.maxNumber(val1.intValue(), val2.intValue(),val3.intValue(),val4.intValue());
					if(temp>maxVal){
						maxVal = temp;
					}
					writer.write(val1.toString() + " ");
				}
				if(val2 != null){
					if(val2.intValue()>maxVal){
						maxVal = val2.intValue();
					}
					writer.write(val2.toString() + " ");
				}
				else {
					writer.write("-" + " ");
				}
				if(val3 != null){
					if(val3.intValue()>maxVal){
						maxVal = val3.intValue();
					}
					writer.write(val3.toString() + " ");
				}
				else {
					writer.write("-" + " ");
				}
				if(val4 != null){
					if(val4.intValue()>maxVal){
						maxVal = val4.intValue();
					}
					writer.write(val4.toString() + " ");
				}
				else {
					writer.write("-" + " ");
				}
				writer.write("\n");
				numClients++; 
					
			}
				
			writer.flush();
			writer.close();
			Utils.setmaxVal(maxVal);
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public void plotNetSatReport(String reg) {
		ResultSet rsReg1;
		
		NetSatReport net;
		Vector<NetSatReport> NetSatReportData = new Vector<NetSatReport>();
		Vector<String> clients = new Vector<String>();
		
		String fileName = new String("/tmp/preg/plots/NetSatReport_" + reg);
		int server_max = 0;
		String cmd = "select distinct client_name from netsat_perf_info where entry_name=\"" 
			+ reg + "\"";
		
		rsReg1 = dbCon.createExecuteQuery(cmd);
		
		try {
			while(rsReg1 != null && rsReg1.next()){
				clients.add(rsReg1.getString("client_name"));
			}
			
			cmd = "select max(num_servers) from netsat_perf_info where entry_name=\"" + reg +"\"";
			rsReg1 = dbCon.createExecuteQuery(cmd);
			while(rsReg1 != null && rsReg1.next()){
				server_max = rsReg1.getInt("max(num_servers)");
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		for(int i = 0; i < clients.size(); i++){
			net = new NetSatReport(clients.elementAt(i));
			cmd = "select num_servers, value from netsat_perf_info where entry_name=\"" 
				+ reg +"\" and client_name=\"" + clients.elementAt(i) + "\" order by num_servers";
			rsReg1 = dbCon.createExecuteQuery(cmd);
			net.enterRegressionData(rsReg1);
			NetSatReportData.add(net);
		}
		generateGnuPlotFile(NetSatReportData, fileName, server_max);
		
		generateGnuPlotScript(fileName, reg, clients, server_max);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
		
	}
	
	public void plotNetSatReport(String reg1, String reg2) {
		ResultSet rsReg1;
		ResultSet rsReg2;
		
		NetSatReport net;
		Vector<NetSatReport> NetSatReportData1 = new Vector<NetSatReport>();
		Vector<NetSatReport> NetSatReportData2 = new Vector<NetSatReport>();
		
		Vector<String> clients1 = new Vector<String>();
		Vector<String> clients2 = new Vector<String>();
		
		
		String fileName = new String("/tmp/preg/plots/NetSatReport_" + reg1 + "_" + reg2);
		int server_max1 = 0, server_max2 = 0, server_max = 0;
		String cmd1 = "select distinct client_name from netsat_perf_info where entry_name=\"" 
			+ reg1 + "\"";
		String cmd2 = "select distinct client_name from netsat_perf_info where entry_name=\"" 
			+ reg2 + "\"";
		
		rsReg1 = dbCon.createExecuteQuery(cmd1);
		rsReg2 = dbCon.createExecuteQuery(cmd2);
		
		try {
			while(rsReg1 != null && rsReg1.next()){
				clients1.add(rsReg1.getString("client_name"));
			}
			
			cmd1 = "select max(num_servers) from netsat_perf_info where entry_name=\"" + reg1 +"\"";
			rsReg1 = dbCon.createExecuteQuery(cmd1);
			while(rsReg1 != null && rsReg1.next()){
				server_max1 = rsReg1.getInt("max(num_servers)");
			}
			
			while(rsReg2 != null && rsReg2.next()){
				clients2.add(rsReg2.getString("client_name"));
			}
			
			cmd2 = "select max(num_servers) from netsat_perf_info where entry_name=\"" + reg2 +"\"";
			rsReg2 = dbCon.createExecuteQuery(cmd2);
			while(rsReg2 != null && rsReg2.next()){
				server_max2 = rsReg2.getInt("max(num_servers)");
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		server_max = (server_max1 <= server_max2)? server_max2 : server_max1;
		
		for(int i = 0; i < clients1.size(); i++){
			net = new NetSatReport(clients1.elementAt(i));
			cmd1 = "select num_servers, value from netsat_perf_info where entry_name=\"" 
				+ reg1 +"\" and client_name=\"" + clients1.elementAt(i) + "\" order by num_servers";
			rsReg1 = dbCon.createExecuteQuery(cmd1);
			net.enterRegressionData(rsReg1);
			NetSatReportData1.add(net);
		}
		
		for(int i = 0; i < clients2.size(); i++){
			net = new NetSatReport(clients2.elementAt(i));
			cmd2 = "select num_servers, value from netsat_perf_info where entry_name=\"" 
				+ reg2 +"\" and client_name=\"" + clients2.elementAt(i) + "\" order by num_servers";
			rsReg2 = dbCon.createExecuteQuery(cmd2);
			net.enterRegressionData(rsReg2);
			NetSatReportData2.add(net);
		}
		generateGnuPlotFile(NetSatReportData1, NetSatReportData2, fileName, server_max);
		
		generateGnuPlotScript(fileName, reg1, reg2, clients1, clients2, server_max);
		runGnuPlot(fileName + ".gnuplot");
		plotGraph(fileName + ".png");
		
	}
	
	private void generateGnuPlotScript(String fName, String reg1, String reg2, Vector<String> clients1,
				Vector<String> clients2, int server_max){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
		String  cmd = new String("plot ");
		int i = 0;
		for(i = 0; i < clients1.size(); i++){
			cmd = cmd + "\"" + inputfile + "\" using 1:"+ (int) (i+2) + " title " + "\'" 
			+ reg1 + clients1.elementAt(i) +"\'" +  " with linespoints,";
		}
		
		for(int j = i; j < clients2.size() + i; j++){
			cmd = cmd + "\"" + inputfile + "\" using 1:"+ (int) (j+2) + " title " + "\'" 
			+ reg2 + clients2.elementAt(j-i) +"\'" +  " with linespoints,";
		}
		
		String cmd2 = new String(cmd.substring(0, cmd.length() - 2) + "\n");
		
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set title \" NetSat " + " Throughput Vs No.Of Servers " + "\"\n");
			writer.write("set ylabel \"Throughput(MBps)\"\n");
			writer.write("set xlabel \"Number of servers\"\n");
			writer.write("set grid\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write(cmd2);
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void generateGnuPlotFile(Vector<NetSatReport> netSatVec1, Vector<NetSatReport> netSatVec2, 
				String fName, int max_servers){
		
		String fileName = new String(fName + ".dat");
		int maxval = 0;
		try{
			FileWriter writer = new FileWriter(fileName);
			for(int i = 1;  i <= max_servers; i++) {
				writer.write(i + " ");
				for(int j = 0; j< netSatVec1.size(); j++){
					NetSatReport net = netSatVec1.elementAt(j);
					Float val = net.getThroughput(i);
					if(maxval < val.intValue()){
						maxval = val.intValue();
					}
					if(val != null){
						writer.write(val.toString() + " ");
					}
					else{
						writer.write("- ");
					}
				}
				for(int j = 0; j< netSatVec2.size(); j++){
					NetSatReport net = netSatVec2.elementAt(j);
					Float val = net.getThroughput(i);
					if(maxval < val.intValue()){
						maxval = val.intValue();
					}
					if(val != null){
						writer.write(val.toString() + " ");
					}
					else{
						writer.write("- ");
					}
				}
				writer.write("\n");
			}
				
			Utils.setmaxVal(maxval);
			writer.flush();
			writer.close();

		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}

	private void generateGnuPlotFile(Vector<NetSatReport> netSatVec, String fName, int max_servers){
		
		String fileName = new String(fName + ".dat");
		int maxval = 0;
		try{
			FileWriter writer = new FileWriter(fileName);
			
			for(int i = 1;  i <= max_servers; i++) {
				writer.write(i + " ");
				for(int j = 0; j< netSatVec.size(); j++){
					NetSatReport net = netSatVec.elementAt(j);
					Float val = net.getThroughput(i);
					if(maxval < val.intValue()){
						maxval = val.intValue();
					}
					if(val != null){
						writer.write(val.toString() + " ");
					}
					else{
						writer.write("- ");
					}
				}
				writer.write("\n");
			}
				
			Utils.setmaxVal(maxval);
			writer.flush();
			writer.close();

		}
		catch (Exception e){
			e.printStackTrace();
		}
		
		
	}
	
	private void generateGnuPlotScript(String fName, String reg1, Vector<String> clients, int server_max){
		String inputfile = new String(fName + ".dat");
		String outputfile = new String(fName + ".gnuplot");
		String plotName = new String(fName + ".png");
		String  cmd = new String("plot "); 
		for(int i = 0; i < clients.size(); i++){
			cmd = cmd + "\"" + inputfile + "\" using 1:"+ (int) (i+2) + " title " + "\'" 
			+ clients.elementAt(i) +"\'" +  " with linespoints,";
		}
		String cmd2 = new String(cmd.substring(0, cmd.length() - 2) + "\n");
		
		try{
			int yMax = Utils.getMaxVal() + Utils.getMaxVal()/5;
			
			FileWriter writer = new FileWriter(outputfile);
			writer.write("set terminal png small color picsize 800 600 \n");
			writer.write("set pointsize 1.5 \n");
			writer.write("set output\"" + plotName + "\"" + "\n");
			writer.write("set origin 0, 0 \n");
			writer.write("set title \" NetSat " + " Throughput Vs No.Of Servers " + "\"\n");
			writer.write("set ylabel \"Throughput(MBps)\"\n");
			writer.write("set xlabel \"Number of servers\"\n");
			writer.write("set grid\n");
			writer.write("set yr [0:" + yMax + "]\n");
			writer.write(cmd2);
			writer.flush();
			writer.close();

		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void PlotDiskPerformance(String reg){
		ResultSet rs;
		String[]column = {"Server", "cached throughput", "Non Cached Throughput"};
		String [][] rows = new String [20][3];
		TabularResults tResults = new TabularResults();
		
		Vector<DiskPerformanceResults> dperf = new Vector<DiskPerformanceResults>();
		Vector<DiskPerformanceResults> dperfCached = new Vector<DiskPerformanceResults>();
		DiskPerformanceResults dp;
		
		String cmd = "select server_name, run_type, value from disk_perf_info where entry_name like \"" 
			+reg + "%\"";
		
		rs = dbCon.createExecuteQuery(cmd);
		try{
			while(rs != null && rs.next()){
				if(rs.getInt("run_type") == 1){
					dp = new DiskPerformanceResults(rs.getString("server_name"), rs.getFloat("value"));
					dperfCached.add(dp);
				}
				else{
					dp = new DiskPerformanceResults(rs.getString("server_name"), rs.getFloat("value"));
					dperf.add(dp);
				}
			}
			
			for(int i = 0; i < dperfCached.size(); i++){
				rows[i][0] = dperfCached.elementAt(i).getServerName();
				Float val = dperfCached.elementAt(i).getValue();
				rows[i][1] = val.toString();
				Float val2 = new Float(0);
				for(int j = 0; j < dperf.size(); j++){
					if(dperfCached.elementAt(i).getServerName().equals( dperf.elementAt(i).getServerName())){
						val2 = dperf.elementAt(i).getValue();
					}
				}
				rows[i][2] = val2.toString();
			}
			tResults.setColumnNames(column);
			tResults.setRows(rows);
			tResults.createAndShowTable();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void PlotNetworkPerformance(String reg){
		ResultSet rs;
		String[]column = {"Server","Server","Server","Server","Server",
				"Server","Server","Server","Server","Server"};
		String [][] rows = new String [20][20];
		TabularResults tResults = new TabularResults();
		
		Vector<String> clients = new Vector<String>();
		Vector<IperfPerformanceResults> netperf = new Vector<IperfPerformanceResults>();
		IperfPerformanceResults netp;
		
		String cmd = "select distinct client_name from network_perf_info where entry_name like \"" 
			+ reg + "%\"";
		
		rs = dbCon.createExecuteQuery(cmd);
		
		try {
		
			while(rs != null && rs.next()){
				clients.add(rs.getString("client_name"));
			}
		
		
		for (int i = 0; i< clients.size(); i++){
			cmd = "select server_name, value from network_perf_info " +
			"where entry_name like \"" + reg + "%\" and client_name = \"" + clients.elementAt(i) 
			+ "\"";
			
			rs = dbCon.createExecuteQuery(cmd);
			
			while(rs != null && rs.next()){
					
				netp = new IperfPerformanceResults(rs.getString("server_name"), rs.getFloat("value"));
						netperf.add(netp);
					
				}
			
			rows[i+1][0] = clients.elementAt(i);
			System.out.println(clients.elementAt(i) + " " + netperf.size() );
			for(int j = 0; j < netperf.size(); j++){
				
				Float val = netperf.elementAt(j).getValue();
				rows[i+1][j+1] = val.toString();
				rows[0][j+1] = netperf.elementAt(j).getServerName();
			}
				
			netperf.clear();
		}	
					
		tResults.setColumnNames(column);
		tResults.setRows(rows);
		tResults.createAndShowTable();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}
